## obrowser 1.1+dfsg

=== Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
EXAMPLES = $(patsubst examples/%,%, $(wildcard examples/*))
EXAMPLES_TARGETS = $(patsubst examples/%,%.example, $(wildcard examples/*))
OCAMLFIND = ocamlfind
.PHONY: tuto dist plugin

all: rt/caml/stdlib.cma vm.js tuto $(EXAMPLES_TARGETS) examples.html AXO

%.example: 
	@echo "[EXAMPLE] $*"
	@cd examples/$* && $(MAKE) --no-print-directory

AXO:
	@echo "[AXO]"
	@cd axo/ && $(MAKE) --no-print-directory

tuto:
	@echo "[TUTORIAL]"
	@cd tutorial && $(MAKE) --no-print-directory

plugin:
	@echo "[MOZILLA PLUGIN]"
	@cd rt/plugin/npapi && $(MAKE) --no-print-directory

examples.html:
	@echo "[EXAMPLES INDEX]"
	@echo "<body><html><ul>" > $@ ; \
	 for i in $(EXAMPLES) ; do echo "<li><a href='examples/$$i/index.html'>$$i</a></li>" >> $@ ; done ; \
	echo "</ul></body></html>" >> $@

rt/caml/stdlib.cma: $(wildcard rt/caml/*.ml) $(wildcard rt/caml/*.mli)
	cd rt/caml && $(MAKE)

vm.js: 	$(wildcard rt/js/*.js)	
	@echo "[CPP] $@"
	@cpp -DDEBUG -P -Irt/js rt/js/main.js vm.js

clean:
	@echo "[CLEAN]"
	@$(RM) -f rt/js/*~
	@cd rt/caml && $(MAKE) clean
	@rm -f examples.html
	@cd tutorial && $(MAKE) clean
	@$(RM) -f *.exe *.cm* *.so *.a *.dylib *.o *~ *.uue \
                    vm.js server
	@$(RM) -f examples/*/*.exe examples/*/*.cm* examples/*/*.exe.uue
	@for ex in $(EXAMPLES) ; do cd examples/$$ex && $(MAKE) clean && cd ../.. ; done
	@cd axo && $(MAKE) clean

dist: clean
	@if ! [ -d dist ] ; then mkdir dist ; fi
	@B=$$(basename $$(pwd)) ; D=$$(date "+%y%m%d.%H%M") ; \
	 cd .. ; tar cjf $$B.$$D.tbz2 --exclude="*.svn*" --exclude="$$B/dist*" $$B ; mv $$B.$$D.tbz2 $$B/dist ; \
	 echo "[DIST] dist/$$B.$$D.tbz2"

install:
	$(OCAMLFIND) install obrowser META vm.js rt/caml/stdlib.cma rt/caml/*.cmi rt/caml/std_exit.cmo axo/AXO.cma axo/AXO*.cmi
	install -m 644 rt/caml/dllstdlib.so `$(OCAMLFIND) -query obrowser`

uninstall:
	$(OCAMLFIND) remove obrowser

=== axo/Makefile ===


SOURCES= AXOJs.ml AXOLang.ml AXOCom.ml AXOHtml.ml AXOEvents.ml AXOWidgets.ml AXOToolkit.ml
CMOS=$(patsubst %.ml, %.cmo, $(SOURCES))

.PHONY: clean all depend

all:vm.js AXO.cma

AXO.cma: ../rt/caml/stdlib.cma $(CMOS)
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc -a -o $@ $(CMOS)

%.cmi: %.mli ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc -c $<

%.cmo: %.ml ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc -c $<

vm.js: ../vm.js
	@echo "[CP] $@"
	@cp $< $@

../vm.js: ../rt/js/*.js
	@cd .. && $(MAKE) vm.js

../rt/caml/stdlib.cma:  ../rt/caml/*.ml*
	@cd .. && $(MAKE) rt/caml/stdlib.cma

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js

depend:
	@CAMLLIB=../rt/caml ocamldep $(SOURCES)> .depend

=== tutorial/Makefile ===
all: vm.js \
     tutorial.exe.uue \
     hello.exe.uue \
     hello_event.exe.uue \
     hello_dom.exe.uue \
     num_sections.exe.uue \
     inline_img.exe.uue \
     clock.exe.uue \
     colorpicker.exe.uue \
     prod_cons.exe.uue \
     distrib

tutorial.exe:  syntax_common.cmo \
                   syntax_xml.cmo \
                   syntax_js.cmo \
                   syntax_html.cmo \
                   syntax_ocaml.cmo \
                   tutorial.cmo
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc $^ -o $@

%.exe: %.ml ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc $< -o $@

%.cmo: %.ml ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc -c $<

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../vm.js
	@echo "[CP] $@"
	@cp $< $@

../vm.js: ../rt/js/*.js
	@cd .. && $(MAKE) vm.js

 ../rt/caml/stdlib.cma:  ../rt/caml/*.ml*
	@cd .. && $(MAKE) rt/caml/stdlib.cma

distrib:
	ln -s .. distrib

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.uue *.exe vm.js distrib

=== examples/pretty_colours/Makefile ===
DIALECTS=js ocaml xml html
COPIES=syntax_common.ml  $(patsubst %,syntax_%.ml, $(DIALECTS))
SOURCES=$(COPIES) main.ml
CMOS=$(patsubst %.ml, %.cmo, $(SOURCES))

.PHONY: clean depend

all: main.exe.uue vm.js

main.exe: $(CMOS) ../../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $(CMOS) -o $@

%.cmo: %.ml
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc -c $<

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

syntax_%.ml: ../../tutorial/syntax_%.ml
	@echo "[LINK] $@"
	@ln -s $< $@

depend: $(SOURCES)  ../../rt/caml/stdlib.cma
	CAMLLIB=../../rt/caml ocamldep $(SOURCES) >.depend

include .depend

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue $(COPIES) vm.js

=== examples/scribble/Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

.PHONY: clean

all: main.exe.uue vm.js server

%.exe: %.ml ../../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $< -o $@

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

server: server.ml
	@echo "[OCAMLOPT] $@"
	@ocamlopt -I +threads unix.cmxa threads.cmxa str.cmxa $< -o $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

clean:
	@echo "[CLEAN]"
	@rm -f *.o *.cm* server *.uue *~ vm.js

=== examples/wiki/Makefile ===
.PHONY=all clean

all: vm.js
	@OCAMLLIB=`pwd`/../../rt/caml ocamlbuild main.byte
	@uuencode main.byte stdout > main.uue

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

clean:
	@ocamlbuild -clean
	@-/bin/rm -f *~

=== rt/caml/Makefile ===
ML=$(wildcard *.ml)
#CMO=$(patsubst %.ml,%.cmo, $(ML))
CMOS= \
  jSOO_basic_io.cmo pervasives.cmo sys.cmo \
  marshal.cmo obj.cmo lazy.cmo \
  array.cmo list.cmo hashtbl.cmo \
  char.cmo string.cmo \
  stdLabels.cmo arrayLabels.cmo listLabels.cmo stringLabels.cmo \
  set.cmo map.cmo stack.cmo queue.cmo buffer.cmo sort.cmo \
  int32.cmo int64.cmo nativeint.cmo \
  printf.cmo format.cmo scanf.cmo \
  arg.cmo  printexc.cmo \
  digest.cmo random.cmo callback.cmo \
  sys.cmo thread.cmo \
  camlinternalLazy.cmo camlinternalOO.cmo oo.cmo camlinternalMod.cmo \
  jSOO.cmo \
  mutex.cmo complex.cmo parsing.cmo lexing.cmo stream.cmo genlex.cmo \
  js.cmo graphics.cmo regexp.cmo

.PHONY=clean depend exec_compflags

all: exec_compflags pervasives.cmi stdlib.cma std_exit.cmo stubs.c

exec_compflags:
	@chmod +x Compflags

stdlib.cma: stubs.o $(CMOS)
	@echo "[MKLIB] $@"
	@CAMLLIB=. ocamlmklib $^ -o $(basename $@)

%.cmo: %.ml
	@echo "[CAMLC] $@"
	@CAMLLIB=. ocamlc `./Compflags $@` -nostdlib -I . -c $< -o $@

%.cmi: %.mli
	@echo "[CAMLC] $@"
	@CAMLLIB=. ocamlc `./Compflags $@` -nostdlib -I . -c $< -o $@

%.o: %.c
	@echo "[CAMLC] $@"
	@CAMLLIB=. ocamlc `./Compflags $@` -nostdlib -c $< -o $@

stubs.c: $(ML)
	@echo "[STUBS] $<"
	@echo "// stubs extracted from $<" > $@
	@cat $(ML) | perl -e '%s=();s/\s*external\s+([^(][^:]+|\([^)]+\)):\s*([^=]+)=[^"]*"([^%][^"]+).*/\/\/ Caml name: $$1\n\/\/ Type:   $$2\nvoid $$3 () {\n  return ;\n}/ && (exists $$s{$$3} || ($$s{$$3}=true && print)) while(<>)' >> $@

#STUBS=$(patsubst %.ml,%-stubs.c, $(ML))

#stubs.c: $(STUBS)
#	@echo "[STUBS] $@"
#	@cat $^ > $@

#%-stubs.c: %.ml build-stubs/build-stubs.cmo
#	@echo "[STUBS] $<"
#	@camlp4o -o $@.cmo build-stubs/build-stubs.cmo $<

#build-stubs/build-stubs.cmo: build-stubs/build-stubs.ml
#	@echo "[CAMLC] $@"
#	@cd build-stubs && ocamlc -pp camlp4orf -c -I +camlp4 build-stubs.ml && cd ..

depend:
	@echo "[CAMLDEP]"
	@CAMLLIB=. ocamldep -I . *.ml > .depend

include .depend

clean:
	@echo "[CLEAN]"
	@rm -f *.a *.cm* *~ .d stubs.c *.o *.so *-stubs.c build-stubs/build-stubs.cmo

=== debian/changelog ===
obrowser (1.1+dfsg-4) unstable; urgency=low

  * Fix FTBFS with bash due to buggy patch:
    - remove 0006-Set-CAML_LD_LIBRARY_PATH-in-wiki-example.patch
    - add 0006-Set-OCAMLLIB-at-the-right-time-in-wiki-example.patch

 -- Stéphane Glondu <glondu@debian.org>  Thu, 18 Mar 2010 09:59:32 +0100

obrowser (1.1+dfsg-3) unstable; urgency=low

  * Add Set-CAML_LD_LIBRARY_PATH-in-wiki-example.patch
    (fixes FTBFS on bytecode architectures)

 -- Stéphane Glondu <glondu@debian.org>  Tue, 16 Feb 2010 13:28:43 +0100

obrowser (1.1+dfsg-2) unstable; urgency=low

  * Fix FTBFS when building without arch:all packages

 -- Stéphane Glondu <glondu@debian.org>  Tue, 16 Feb 2010 10:03:40 +0100

obrowser (1.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #567887)

 -- Stéphane Glondu <glondu@debian.org>  Sat, 06 Feb 2010 15:25:38 +0100

=== debian/control ===
Source: obrowser
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper (>= 7.1.0~),
 dh-ocaml (>= 0.9~),
 ocaml-findlib,
 sharutils,
 ocaml-nox (>= 3.11.1-3~)
Standards-Version: 3.8.4
Section: ocaml
Homepage: http://ocsigen.org/obrowser/
Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/obrowser.git
Vcs-Git: git://git.debian.org/git/pkg-ocaml-maint/packages/obrowser.git

Package: libobrowser-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib, libjs-obrowser, sharutils
Description: O'Browser support libraries (development files)
 O'Browser is an OCaml virtual machine written in Javascript. It runs
 bytecode executables produced by the regular bytecode compiler and
 gives the possibility to run OCaml programs directly in a web
 browser. You can use it with any Web server.
 .
 This package contains support libraries to manipulate the DOM tree
 and widgets for use in programs meant to be run in O'Browser.

Package: libjs-obrowser
Architecture: all
Depends: ${misc:Depends}
Recommends: javascript-common
Description: OCaml virtual machine written in Javascript (runtime)
 O'Browser is an OCaml virtual machine written in Javascript. It runs
 bytecode executables produced by the regular bytecode compiler and
 gives the possibility to run OCaml programs directly in a web
 browser. You can use it with any Web server.
 .
 This package contains the virtual machine itself.

Package: obrowser-doc
Architecture: all
Depends: ${misc:Depends}
Section: doc
Description: OCaml virtual machine written in Javascript (doc)
 O'Browser is an OCaml virtual machine written in Javascript. It runs
 bytecode executables produced by the regular bytecode compiler and
 gives the possibility to run OCaml programs directly in a web
 browser. You can use it with any Web server.
 .
 This package contains a tutorial and examples, as well as the HTML
 API documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/ocaml/ocamlvars.mk

DOCDIR = debian/obrowser-doc/usr/share/doc/obrowser-doc
export OCAMLFIND_DESTDIR=$(CURDIR)/debian/tmp/$(OCAML_STDLIB_DIR)

%:
	dh --with ocaml $@

.PHONY: override_dh_auto_install
override_dh_auto_install:
	install -d $(OCAMLFIND_DESTDIR)
	$(MAKE) install

.PHONY: override_dh_ocaml
override_dh_ocaml:
	dh_ocaml -Xstdlib.cma -Xmutex.cmi -Xstd_exit.cmo \
	  `cd $(OCAML_STDLIB_DIR) && for u in *.cmi; do echo -n " -X$$u"; done`

.PHONY: override_dh_install
override_dh_install:
	dh_install --list-missing
ifneq (,$(findstring obrowser-doc, $(shell dh_listpackages)))
# Build the documentation packages
	cp -a examples tutorial $(DOCDIR)
# Clean up inappropriate files
	find $(DOCDIR) \( \
	  -name '*.exe' -or \
	  -name '*.cm*' -or \
	  -name '*.byte' -or \
	  -name '*.o' -or \
	  -name .depend -or \
	  -name LICENSE \
	\) -delete
	rm -f $(DOCDIR)/tutorial/distrib
	rm -f $(DOCDIR)/examples/scribble/server
endif

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress -X.js -X.uue

## obrowser 1.1.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -16,9 +16,16 @@
 EXAMPLES = $(patsubst examples/%,%, $(wildcard examples/*))
 EXAMPLES_TARGETS = $(patsubst examples/%,%.example, $(wildcard examples/*))
 OCAMLFIND = ocamlfind
-.PHONY: tuto dist plugin
+.PHONY: tuto dist plugin lwt
 
-all: rt/caml/stdlib.cma vm.js tuto $(EXAMPLES_TARGETS) examples.html AXO
+all: .check_version rt/caml/stdlib.cma vm.js tuto $(EXAMPLES_TARGETS) examples.html AXO lwt
+
+.check_version:
+	@[ "$(shell ocamlc -vnum)" = "3.12.0" ] || \
+	  [ "$(shell ocamlc -vnum)" = "3.12.1" ] || \
+	  ( echo "You need ocaml version 3.12.0 or 3.12.1"; \
+            exit 1 )
+	touch $@
 
 %.example: 
 	@echo "[EXAMPLE] $*"
@@ -27,6 +34,10 @@
 AXO:
 	@echo "[AXO]"
 	@cd axo/ && $(MAKE) --no-print-directory
+
+lwt:
+	@echo "[LWT]"
+	@cd lwt/ && $(MAKE) --no-print-directory
 
 tuto:
 	@echo "[TUTORIAL]"
@@ -48,6 +59,7 @@
 vm.js: 	$(wildcard rt/js/*.js)	
 	@echo "[CPP] $@"
 	@cpp -DDEBUG -P -Irt/js rt/js/main.js vm.js
+	@cat rt/js/ffi.js >> vm.js
 
 clean:
 	@echo "[CLEAN]"
@@ -55,21 +67,22 @@
 	@cd rt/caml && $(MAKE) clean
 	@rm -f examples.html
 	@cd tutorial && $(MAKE) clean
+	@cd lwt && $(MAKE) clean
 	@$(RM) -f *.exe *.cm* *.so *.a *.dylib *.o *~ *.uue \
                     vm.js server
 	@$(RM) -f examples/*/*.exe examples/*/*.cm* examples/*/*.exe.uue
 	@for ex in $(EXAMPLES) ; do cd examples/$$ex && $(MAKE) clean && cd ../.. ; done
 	@cd axo && $(MAKE) clean
 
+
+VERSION := $(shell head -n 1 VERSION)
+
 dist: clean
-	@if ! [ -d dist ] ; then mkdir dist ; fi
-	@B=$$(basename $$(pwd)) ; D=$$(date "+%y%m%d.%H%M") ; \
-	 cd .. ; tar cjf $$B.$$D.tbz2 --exclude="*.svn*" --exclude="$$B/dist*" $$B ; mv $$B.$$D.tbz2 $$B/dist ; \
-	 echo "[DIST] dist/$$B.$$D.tbz2"
+	darcs dist -d obrowser-$(VERSION)
 
 install:
-	$(OCAMLFIND) install obrowser META vm.js rt/caml/stdlib.cma rt/caml/*.cmi rt/caml/std_exit.cmo axo/AXO.cma axo/AXO*.cmi
-	install -m 644 rt/caml/dllstdlib.so `$(OCAMLFIND) -query obrowser`
+	$(OCAMLFIND) install -patch-version ${VERSION} obrowser META vm.js rt/js/ffi.js rt/caml/stdlib.cma rt/caml/*.cmi rt/caml/std_exit.cmo axo/AXO.cma axo/AXO*.cmi lwt/lwt_obrowser.cma lwt/lwt_*.cmi
+	install -m 644 rt/caml/dllstdlib.so `$(OCAMLFIND) -printconf destdir`/obrowser
 
 uninstall:
 	$(OCAMLFIND) remove obrowser

=== lwt/Makefile ===


SOURCES= lwt_preemptive.ml lwt_obrowser.ml
CMOS=$(patsubst %.ml, %.cmo, $(SOURCES))

LWTDIR=`ocamlfind query lwt`
OPTIONS=-I $(LWTDIR) -I ../axo


.PHONY: clean all depend

all:depend lwt_preemptive.cmi lwt_obrowser.cma

lwt_obrowser.cma: ../rt/caml/stdlib.cma $(CMOS)
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc -a -o $@ $(CMOS)

%.cmi: %.mli ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc $(OPTIONS) -c $<

%.cmo: %.ml ../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../rt/caml ocamlc $(OPTIONS) -c $<

../rt/caml/stdlib.cma:  ../rt/caml/*.ml*
	@cd .. && $(MAKE) rt/caml/stdlib.cma

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js .depend

.depend:
	@CAMLLIB=../rt/caml ocamldep $(SOURCES)> .depend


include .depend

=== examples/boulderdash/Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

.PHONY: clean

all: main.exe.uue vm.js

%.exe: %.ml ../../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $< -o $@

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js

=== examples/frames/Makefile ===
SOURCES=boot.ml events.ml style.ml geometry.ml main.ml
CMOS=$(patsubst %.ml, %.cmo, $(SOURCES))

.PHONY: clean all depend

all: main.exe.uue vm.js

main.exe: $(CMOS) ../../rt/caml/stdlib.cma ../../axo/AXO.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc -I ../../axo AXO.cma $(CMOS) -o $@

%.cmo: %.ml ../../rt/caml/stdlib.cma  ../../axo/AXO.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc -I ../../axo/ -c $<

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

../../axo/AXO.cma: ../../axo/*.ml
	@cd ../.. && $(MAKE) AXO

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js

include .depend

depend:
	@CAMLLIB=../../rt/caml ocamldep $(SOURCES)> .depend

=== examples/lwt/Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

LWTDIR=`ocamlfind query lwt`
OPTIONS=-I $(LWTDIR) -I ../../lwt

.PHONY: clean

all: main.exe.uue vm.js

%.exe: %.ml ../../rt/caml/stdlib.cma ../../lwt/lwt_obrowser.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $(OPTIONS) lwt.cma lwt_obrowser.cma $< -o $@

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

../../lwt/lwt_obrowser.cma: ../../lwt/*.ml*
	@cd ../.. && $(MAKE) lwt


clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js

=== examples/minesweeper/Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

.PHONY: clean

all: main.exe.uue minesweeper.exe.uue vm.js

%.exe: %.ml ../../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $< -o $@

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js

=== examples/viewer/Makefile ===
# Caml Virtual Machine in JavaScript       
# (C) 2007 Benjamin Canou (Benjamin.Canou@gmail.com)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

.PHONY: clean

all: main.exe.uue vm.js thumbs pictures

%.exe: %.ml ../../rt/caml/stdlib.cma
	@echo "[OCAMLC] $@"
	@CAMLLIB=../../rt/caml ocamlc $< -o $@

%.uue: %
	@echo "[UUENCODE] $@"
	@uuencode $^ stdout > $@

vm.js: ../../vm.js
	@echo "[CP] $@"
	@cp $< $@

../../vm.js: ../../rt/js/*.js
	@cd ../.. && $(MAKE) vm.js

 ../../rt/caml/stdlib.cma:  ../../rt/caml/*.ml*
	@cd ../.. && $(MAKE) rt/caml/stdlib.cma

thumbs:
	@echo "[LINK] $@"
	@ln -s ../../tutorial/thumbs .

pictures:
	@echo "[LINK] $@"
	@ln -s ../../tutorial/pictures .

clean:
	@echo "[CLEAN]"
	@rm -f *.cm* *~ *.exe *.uue vm.js thumbs pictures

=== examples/wiki/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 .PHONY=all clean
 
 all: vm.js
-	@OCAMLLIB=`pwd`/../../rt/caml ocamlbuild main.byte
+	@ocamlbuild -ocamlc 'OCAMLLIB=$(PWD)/../../rt/caml ocamlc' main.byte
 	@uuencode main.byte stdout > main.uue
 
 vm.js: ../../vm.js

=== rt/caml/Makefile ===
--- 
+++ 
@@ -1,21 +1,22 @@
 ML=$(wildcard *.ml)
 #CMO=$(patsubst %.ml,%.cmo, $(ML))
 CMOS= \
-  jSOO_basic_io.cmo pervasives.cmo sys.cmo \
+  pervasives.cmo sys.cmo \
+  int32.cmo int64.cmo nativeint.cmo \
+  array.cmo list.cmo hashtbl.cmo \
   marshal.cmo obj.cmo lazy.cmo \
-  array.cmo list.cmo hashtbl.cmo \
   char.cmo string.cmo \
   stdLabels.cmo arrayLabels.cmo listLabels.cmo stringLabels.cmo \
   set.cmo map.cmo stack.cmo queue.cmo buffer.cmo sort.cmo \
-  int32.cmo int64.cmo nativeint.cmo \
   printf.cmo format.cmo scanf.cmo \
   arg.cmo  printexc.cmo \
   digest.cmo random.cmo callback.cmo \
   sys.cmo thread.cmo \
   camlinternalLazy.cmo camlinternalOO.cmo oo.cmo camlinternalMod.cmo \
   jSOO.cmo \
-  mutex.cmo complex.cmo parsing.cmo lexing.cmo stream.cmo genlex.cmo \
-  js.cmo graphics.cmo regexp.cmo
+  mutex.cmo condition.cmo \
+  complex.cmo parsing.cmo lexing.cmo stream.cmo genlex.cmo \
+  js.cmo graphics.cmo regexp.cmo weak.cmo
 
 .PHONY=clean depend exec_compflags
 
@@ -61,7 +62,7 @@
 
 depend:
 	@echo "[CAMLDEP]"
-	@CAMLLIB=. ocamldep -I . *.ml > .depend
+	@CAMLLIB=. ocamldep -I . *.ml *.mli > .depend
 
 include .depend

=== debian/changelog ===
obrowser (1.1.1+dfsg-1) unstable; urgency=low

  * New upstream release
    - compatible with OCaml 3.12.0 (Closes: #580105)
  * Add liblwt-ocaml-dev to Build-Depends
  * Bump Standards-Version to 3.9.2 (no changes)

 -- Stéphane Glondu <glondu@debian.org>  Fri, 22 Apr 2011 23:34:41 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,11 @@
 Build-Depends:
  debhelper (>= 7.1.0~),
  dh-ocaml (>= 0.9~),
+ liblwt-ocaml-dev,
  ocaml-findlib,
  sharutils,
  ocaml-nox (>= 3.11.1-3~)
-Standards-Version: 3.8.4
+Standards-Version: 3.9.2
 Section: ocaml
 Homepage: http://ocsigen.org/obrowser/
 Vcs-Browser: http://git.debian.org/?p=pkg-ocaml-maint/packages/obrowser.git

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 
 .PHONY: override_dh_ocaml
 override_dh_ocaml:
-	dh_ocaml -Xstdlib.cma -Xmutex.cmi -Xstd_exit.cmo \
+	dh_ocaml -Xstdlib.cma -Xmutex.cmi -Xcondition.cmi -Xstd_exit.cmo \
 	  `cd $(OCAML_STDLIB_DIR) && for u in *.cmi; do echo -n " -X$$u"; done`
 
 .PHONY: override_dh_install

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\d*$// \
http://ocsigen.org/obrowser/install ../download/obrowser-(.*)\.tar\.gz
